/*    
    Copyright (C) 2006  Andrea Detti, Remo Pomposini
    This file is part of "Obamp Proxy v2",

    "Obamp Proxy v2" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy v2" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.io.*;
import java.awt.*;
import java.util.*;
import Multicast.*;
import java.net.*;
import java.lang.System;
import prominence.util.Queue;


public class  DataManager implements Runnable{

	protected Thread exec;
	protected Signalling sig;
	protected InetAddress myIP;
	protected TextArea outputArea;
	protected Hashtable nb;
	protected Hashtable dataSource;
	protected Hashtable cacheID;
	protected byte myID;
	protected Queue q;
	protected Queue qApp;
	protected Queue qReq;
	    
    protected UnicastTreeDataSender UnicastTreeDataSender_;
    protected AppSender AppSender_;
    protected byte mIP;
    protected int dataport;
    protected int appRCVport;
    protected int appTXport;
    
    private byte ind [];
    private DB_Contest db;
    private UnicastTreeDataReceiver dataR;
    private AppReceiver appR;
    private rcvPKTid []dataCache;
    private int data_counter;
	private byte[] rcvPKT;	
	private byte[] previousHOP;
	private boolean ret;
	
	private MulticastTreeDataSender MdataS;
	private MulticastTreeDataReceiver MdataR;
	private int multicast_data_port;
	private InetAddress multicast_data_address;
	
	protected Checkbox enable_broadcast;
	
	public DataManager () throws Exception {
     
        db = new DB_Contest("obamp.cfg");
    	dataport = new Integer( db.get("data_port")).intValue();
    	appRCVport = new Integer( db.get("app_rcv_port")).intValue();
    	appTXport = new Integer( db.get("app_tx_port")).intValue();
    	multicast_data_port = new Integer (db.get("multicast_data_port")).intValue();
    	multicast_data_address = InetAddress.getByName(db.get("multicast_address"));
    	myIP = InetAddress.getByName(db.get("local_address"));
    	
    	q = new Queue();
     	qApp = new Queue();
     	qReq = new Queue();
     	
     	
     	dataCache = new rcvPKTid[100];
     
     	ind = myIP.getAddress();
        mIP = ind [3];
        previousHOP = myIP.getAddress();
        data_counter=0;
     	
     	dataSource = new Hashtable();
     	cacheID = new Hashtable();
     	myID = 0;
     	cacheID.put(new Integer(myID), new Long(System.currentTimeMillis()));
     	dataSource.put(new Byte(mIP), cacheID);
    	
        new purge_cacheID(this);
        
     	exec = new Thread (this);
     	//exec.setPriority(1);
     	exec.start ();
     
   	}
   	
   	public void setTextArea (TextArea area1, Checkbox enable_broadcast_) {
     	this.outputArea = area1;
     	enable_broadcast = enable_broadcast_;
     	
    }
 
	public void setSignalling (Signalling sig_) {
     	this.sig = sig_;
     
   	}
        
       
   	
   	public void setHash (Hashtable nb_) {
     	this.nb = nb_;
     
   	}
   	
   	
   	public void purge () {
   		
   		Enumeration e = dataSource.keys(); // get all keys stored in Hashtable 
    	while (e.hasMoreElements()) {
    		Object key = e.nextElement(); // nextElement returns an Object
    		Hashtable cache = (Hashtable)dataSource.get(key); // nextElement returns an Object
    		
    		Enumeration en = cache.keys(); // get all keys stored in Hashtable 
    		while (en.hasMoreElements()) {
    			Object id = en.nextElement(); // nextElement returns an Object
    			Long value = (Long)cache.get(id); // nextElement returns an Object
    			long timearrival = value.longValue();
    			if ((System.currentTimeMillis()-timearrival)>10000){
    				cache.remove(id);		
    			}
    		    	
    		}
    		
    	}
   	}
   	
   	public void node_map_insert(int id, byte[] pkt_) {
        
        int ref_byte,ref_bit;
        byte insert_char=0x01;
        ref_byte=(int)id/8;
        ref_bit=id % 8;
        insert_char=(byte)(insert_char<<ref_bit);
        pkt_[ref_byte+2]=(byte)(pkt_[ref_byte+2]|(insert_char));
        return;
   	}
   	
   	public boolean node_map_lookup(int id, byte[] pkt_) {
       
        int ref_byte,ref_bit;
        byte insert_char=0x01;
        ref_byte=(int)id/8;
        ref_bit=(id) % (8);
        insert_char=(byte)(insert_char<<ref_bit);
        if(((pkt_[ref_byte+2]) & (insert_char))==0x00) {
                return(false);
        } else {
                return(true);
        }
   	}
         	

	public boolean checkData(rcvPKTid id){
		
		ret = false;
		for (short i=0; i<100; i++) {
			rcvPKTid key = dataCache[i];
			if (key!=null)
			if (key.sourceIP == rcvPKT[1] && key.sequence_number == rcvPKT[0]) {
				ret = true;
				break;
			}
			
		}
		return ret;
	}
		  	
   	
   	
    public void receiveData (DatagramPacket pkt_) {
    	
    	
    	rcvPKT = pkt_.getData();//new byte[];
    	
    	rcvPKTid pktID = new rcvPKTid(rcvPKT[0], rcvPKT[1]);
    	if (rcvPKT[1] == mIP) return;
    	if (checkData(pktID)){
    		return;
    	}else {
    		dataCache[data_counter % 100]=pktID;
    		forwardData(rcvPKT);
    		AppSender_.q.add(pkt_);
    	}
    	data_counter ++;	
    	
    }
    public void sendData (DatagramPacket packet) {
   			
    	UnicastData[] UnicastTreeDataSendArray = new UnicastData[64];
    	UnicastData[] MulticastTreeDataSendArray = new UnicastData[64];
    	
    	boolean multicast_done = false;
    	int number_of_sent=0;
    	int number_of_multicast_sent = 0;
    	
    	int dataID = (int)myID;
        if(dataID<0)
            dataID = dataID + 256;
        dataID = dataID + 1;
        if(dataID>255)
            dataID = 1;
        myID = (byte)dataID;
        
    	byte[] buffer = packet.getData();
        buffer[0] = myID;
        buffer[1] = mIP;
        node_map_insert((int)mIP, buffer);    
        
        synchronized(sig.signalling_use){
        
	    	Enumeration en = sig.neighbors.keys(); // get all keys stored in Hashtable 
	    	
	        while (en.hasMoreElements()) {
	    		Object key = en.nextElement(); // nextElement returns an Object
	    		OverlayNeighbor  value = (OverlayNeighbor)sig.neighbors.get(key); // nextElement returns an Object
	    		if(enable_broadcast.getState()){
	    			if (value.istree == true && value.distance>1){
		    			node_map_insert(value.IP, buffer);   
		    			number_of_sent++;
		    			UnicastTreeDataSendArray[number_of_sent-1] = new  UnicastData(buffer,value.IPAddress);
		    		} else {
		    			if (value.distance==1) {
		    				if(value.isSimNeighbor) node_map_insert(value.IP, buffer); 
		    				if (multicast_done==false) {
		    					number_of_multicast_sent++;
		    					MulticastTreeDataSendArray[number_of_multicast_sent-1] = new  UnicastData(buffer,multicast_data_address);
		    					multicast_done=true;
		    				}
		    			}
		    		}
	    		}else if(value.istree){
	    			node_map_insert(value.IP, buffer);   
	    			number_of_sent++;
	    			UnicastTreeDataSendArray[number_of_sent-1] = new  UnicastData(buffer,value.IPAddress);
	    		}
	    		
	        }
        }
        for (int i=0;i<number_of_multicast_sent;i++) {
        	MdataS.q.add(MulticastTreeDataSendArray[i]);
        }
        for (int i=0;i<number_of_sent;i++) {
        	UnicastTreeDataSender_.q.add(UnicastTreeDataSendArray[i]);
        }
    }
    
    public void forwardData (byte[] buffer) {
        
    	UnicastData[] UnicastTreeDataSendArray = new UnicastData[64];
    	UnicastData[] MulticastTreeDataSendArray = new UnicastData[64];
    	
    	int number_of_sent=0;
    	int number_of_multicast_sent=0;
    	boolean multicast_done = false;
    	
    	synchronized(sig.signalling_use){
    	
    		Enumeration en = sig.neighbors.keys(); // get all keys stored in Hashtable 
	    	while (en.hasMoreElements()) {
	            Object key = en.nextElement(); // nextElement returns an Object
	            OverlayNeighbor  value = (OverlayNeighbor)sig.neighbors.get(key); // nextElement returns an Object
	            if (!node_map_lookup(value.IP, buffer)) {
	            	if (value.istree == true && value.distance>1 ){
	                	node_map_insert(value.IP, buffer);   
	        			number_of_sent++;
	        			UnicastTreeDataSendArray[number_of_sent-1] = new  UnicastData(buffer ,value.IPAddress);
	     			} else {
	     				if (value.distance==1) {
	     					if(value.isSimNeighbor) node_map_insert(value.IP, buffer); 
	        				if (multicast_done==false) {
	        					number_of_multicast_sent++;
	        					MulticastTreeDataSendArray[number_of_multicast_sent-1] = new  UnicastData(buffer,multicast_data_address);
	        					multicast_done=true;
	        				}
	        			}
	     			}
	            }
	        }
    	}
    	
    	for (int i=0;i<number_of_multicast_sent;i++) {
        	MdataS.q.add(MulticastTreeDataSendArray[i]);
        }
    	for (int i=0;i<number_of_sent;i++) {
        	UnicastTreeDataSender_.q.add(UnicastTreeDataSendArray[i]);
        }
   }
    
    
   	
	public void run () {
		
		dataR = new UnicastTreeDataReceiver(dataport, myIP, sig);//dataport);
    	dataR.setDataManager(this);
    	appR = new AppReceiver(appRCVport, myIP);
        appR.setDataManager(this);
        MdataR = new MulticastTreeDataReceiver(myIP, multicast_data_port, multicast_data_address);
        MdataR.setDataManager(this);    	
        UnicastTreeDataSender_ = new UnicastTreeDataSender(myIP, dataport-1, dataport, sig);
        AppSender_ = new AppSender(myIP, appRCVport-1, appTXport);
        MdataS = new MulticastTreeDataSender(myIP, multicast_data_port);
		            
        while(true){
			
        	qReq.remove();
        	if (!q.isEmpty()) receiveData((DatagramPacket)q.remove());         	
        	if (!qApp.isEmpty()) sendData((DatagramPacket)qApp.remove());
        	
        	
			//if (q.isEmpty() && qApp.isEmpty()) {
		    	try {
					Thread.sleep(1);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			//}
			
		}	
   		
   }
	
	
}
