/*    
    Copyright (C) 2006  Andrea Detti, Remo Pomposini
    This file is part of "Obamp Proxy v2",

    "Obamp Proxy v2" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy v2" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;

import Multicast.OverlayNeighbor;


public class FastHelloTimer {
    
    Timer timer;
    Signalling agent;
    
	
    public FastHelloTimer(Signalling agent_) {
		agent = agent_;
        timer = new Timer();
        timer.schedule(new HelloTask(), 
                agent.fast_HELLO_INT,
                agent.fast_HELLO_INT);
	    
    }
    
    public void handle(){
                
    		Enumeration e = agent.neighbors.keys(); // get all keys stored in Hashtable 
            while (e.hasMoreElements()) {
            	Object key = e.nextElement(); // nextElement returns an Object    		
                OverlayNeighbor nb = (OverlayNeighbor)agent.neighbors.get(key); 
                //if (nb.distance==1){
                	int FHSN = (int)agent.state.FastHelloSequenceNumber;
                    if(FHSN<0)
                    	FHSN = FHSN + 256;
                    FHSN = FHSN + 1;
                    if(FHSN>255)
                    	FHSN = 1;
                    agent.state.FastHelloSequenceNumber = (byte)FHSN;
                    synchronized(agent.signalling_use){
                    	agent.sendFastHello();
                    }
                	return;
                //}
            }
    }

    class HelloTask extends TimerTask {
	
        public void run() {
                       
            handle();
            
        }
    } 
} 