/*    
    Copyright (C) 2006  Andrea Detti, Remo Pomposini
    This file is part of "Obamp Proxy v2",

    "Obamp Proxy v2" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy v2" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;

import Multicast.OverlayNeighbor;


public class HelloTimer {
    
    Timer timer;
    Signalling agent;
        
	
    public HelloTimer(Signalling agent_) {
	   	agent = agent_;
        timer = new Timer();
        timer.schedule(new HelloTask(), 
                0,
                agent.HELLO_INT);
	    
    }
    
    public void handle(){
                
    		Enumeration e = agent.neighbors.keys(); // get all keys stored in Hashtable 
            while (e.hasMoreElements()) {
            	Object key = e.nextElement(); // nextElement returns an Object    		
                OverlayNeighbor nb = (OverlayNeighbor)agent.neighbors.get(key); 
            	if (nb.distance<=1 && nb.isSimNeighbor){
            		return;
            	}    
            }
            agent.state.hello_request_number=0;
            agent.state.hello_req_last_ttl=2;
            agent.SetNeighborMinDistance();
            agent.state.hello_found_neighbour = false;
            agent.state.hello_timeout1 = System.currentTimeMillis() + agent.HELLO_INT;
            long short_hello_interval = 3*10*10*agent.state.hello_req_last_ttl;
            new ersTimer(agent, 2, short_hello_interval, agent.state.hello_req_last_ttl);   
    	
            	
    		
           
	}
    
    
    class HelloTask extends TimerTask {
	
        public void run() {
                       
            handle();
            
        }
    } 
} 