/*    
    Copyright (C) 2006  Andrea Detti, Remo Pomposini
    This file is part of "Obamp Proxy v2",

    "Obamp Proxy v2" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy v2" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.util.Timer;
import java.util.TimerTask;


public class ersTimer {
    
    Timer timer;
    Signalling agent;
    int count;
    int TTL;
    int id;
    	
    public ersTimer(Signalling agent_, int id_, long delay_, int TTL_) {
	count = 0;
	agent = agent_;
        id = id_;
        TTL = TTL_;
        timer = new Timer();
        timer.schedule(new ersTask(), delay_);
	    
    }
    
    public void handle(){
        
        switch (id) {
    		
    		case 1://Join Request
         		
                    if (agent.state.is_core){
                    if (agent.state.found_neighbour == false && System.currentTimeMillis()<agent.state.req_timeout1){
                        int RSN = (int)agent.state.request_number;
                        if(RSN<0)
                            RSN = RSN + 256;
                            RSN = RSN + 1;
                        if(RSN>255)
                            RSN = 1;
                        agent.state.request_number = (byte)RSN;
                        synchronized(agent.signalling_use){
                        	agent.sendJoinReq(TTL);
                        }
                        agent.state.req_last_ttl++;
                        if (agent.state.req_last_ttl <= agent.state.MAX_TTL){
                            long short_req_interval = 3*10*10*agent.state.hello_req_last_ttl;
                            new ersTimer(agent, 1, short_req_interval, agent.state.req_last_ttl);
                        }
                    }
                    }
                    break;
           	case 2://Hello
                    
                    
                    if (agent.state.hello_found_neighbour == false && System.currentTimeMillis()<agent.state.hello_timeout1){
                        int HSN = (int)agent.state.hello_seq_num;
                        if(HSN<0)
                            HSN = HSN + 256;
                        HSN = HSN + 1;
                        if(HSN>255)
                            HSN = 1;
                        agent.state.hello_seq_num = (byte)HSN;
                        synchronized(agent.signalling_use){
                        	agent.sendHello((byte)TTL);
                        }
                        agent.state.hello_count++;
                        agent.state.hello_req_last_ttl++;
                        if (agent.state.hello_req_last_ttl <= agent.state.hello_max_ttl){
                            long short_hello_interval = 3*10*10*agent.state.hello_req_last_ttl;
                            new ersTimer(agent, 2, short_hello_interval, agent.state.hello_req_last_ttl);
                        }
                    }
                    //}
                    break;
           	
           			
        }    		
    		
    		
    }

    class ersTask extends TimerTask {
	
        public void run() {
                       
            handle();
            timer.cancel();
        }
    } 
} 