/*    
    Copyright (C) 2006  Andrea Detti, Remo Pomposini
    This file is part of "Obamp Proxy v2",

    "Obamp Proxy v2" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy v2" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.io.*;
import java.net.*;


public class pktFastHello {
	
	
	//packet variables: 5 Bytes + 8 Bytes (Fired_Node_Map)
    protected byte MessageID;
    protected byte SourceIP;
    protected byte CoreAddress;
	protected byte SequenceNumber;	
	protected byte TTL = 1;
	
	protected byte[] Fired_Node_Map;
        	
 	//complementary variables 
    protected InetAddress SourceIPAddress;	
	protected InetAddress IPCoreAddress;	
	protected byte[] address;
 	protected int sourcePort;  	  	
  	//protected byte[] data;  
  	protected int destPort;
  	
  	protected byte[] data = new byte [13];  
  	
  	public pktFastHello(InetAddress address_) {
  	  	MessageID = 13;	
  	  	address = address_.getAddress();
  	}
  	
  	
  	public pktFastHello(byte SequenceNumber_, InetAddress SourceIPAddress_, InetAddress IPCoreAddress_, byte[] node_map) {
  		
  		MessageID = 13;
        SequenceNumber = SequenceNumber_;
  		SourceIPAddress = SourceIPAddress_;
  		IPCoreAddress = IPCoreAddress_;
  		
        address = SourceIPAddress.getAddress();
        this.SourceIP = address [3];
        byte indC [] = IPCoreAddress.getAddress();
        this.CoreAddress = indC [3];
        
        data[0] = MessageID;
		data[1] = TTL;
		data[2] = this.SourceIP;
		data[3] = this.CoreAddress;
		data[4] = this.SequenceNumber;
		
		for (int element = 5; element < node_map.length; element++){
			data[element] = node_map[element];
		}
  		  		  		
  	}
  	
  	public void SetpktFastHello(byte[] pkt){
  		
		try{
            data = pkt;        
            //settings variables
            MessageID = 5;//pkt[0];
            int fTTL = pkt[1];
            SourceIP = pkt[2];
            CoreAddress = pkt[3];
            SequenceNumber = pkt[4];
            
                        
            byte ind [] = new byte[4];
            ind[0] = address[0];
            ind[1] = address[1];
            ind[2] = address[2];
            ind[3] = SourceIP;
            this.SourceIPAddress = InetAddress.getByAddress(ind);
            byte indC [] = new byte[4];
            indC[0] = address[0];
            indC[1] = address[1];
            indC[2] = address[2];
            indC[3] = CoreAddress;
            this.IPCoreAddress = InetAddress.getByAddress(indC);
  			 	
  		 } catch (IOException ex) {
  			
  		}
  		return;
        
    }
  	  	  	
  	  	
  	//it sets the packet by an input stream
  	public void SetpktFastHello(DataInputStream qI){
  		
  		
		try{
                    
                    //settings variables		  		  		
                    MessageID = qI.readByte();//13;
                    int fTTL = qI.readByte();
                    SourceIP = qI.readByte();
                    CoreAddress = qI.readByte();
                    SequenceNumber = qI.readByte();
                                                                        
                    byte ind [] = new byte[4];
                    ind[0] = address[0];
                    ind[1] = address[1];
                    ind[2] = address[2];
                    ind[3] = SourceIP;
                    this.SourceIPAddress = InetAddress.getByAddress(ind);
                    byte indC [] = new byte[4];
                    indC[0] = address[0];
                    indC[1] = address[1];
                    indC[2] = address[2];
                    indC[3] = CoreAddress;
                    this.IPCoreAddress = InetAddress.getByAddress(indC);
		  		  		
  		 } catch (IOException ex) {
  			
  		}
  		return;
        
    }
  	
  	public byte[] getData(){
  		
  		return data;
		
    }
  	
  	public byte[] GetpktFastHello(){
  		
  		
  		try {
                    
            ByteArrayOutputStream boStream = new ByteArrayOutputStream ();
            DataOutputStream doStream = new DataOutputStream (boStream);
            doStream.writeByte(MessageID);
            doStream.writeByte(TTL);
            doStream.writeByte(SourceIP);
            doStream.writeByte(CoreAddress);
            doStream.writeByte(SequenceNumber); 
           
            data = boStream.toByteArray ();
  			
        } catch (IOException ex) {
        	ex.printStackTrace ();
        }
        
        return data;
        
    }
  		
}